<!-- Copyright (C) Perinet -->
<!DOCTYPE html>
<html>
	<head>
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />

		<title>Alpine Container</title>

		<link rel="stylesheet" type="text/css" href="css/base.css" />
		<link rel="stylesheet" type="text/css" href="css/framing.css" />
		<link rel="stylesheet" type="text/css" href="css/home.css" />
		<link rel="stylesheet" type="text/css" href="css/style.css" />
		<link rel="stylesheet" type="text/css" href="css/switches.css" />
		<link rel="stylesheet" type="text/css" href="css/help-tip.css" />
		<link rel="stylesheet" type="text/css" href="css/keyframes.css" />
		<link rel=icon type="image/png" href=/favicon.ico>
		<script type="text/javaScript" src="js/jquery-3.6.0.min.js"></script>
		<script type="text/javaScript" src="js/cert_decoder.js"></script>
		<script type="text/javaScript" src="js/security.js"></script>
		<script type="text/javaScript">
			function generate_otp() {
				$.get( "/ssh/otp", function( data ) {
					let otp = String( parseInt(data.otp) ).padStart(6, '0');
					$( '#otp_text' ).val(otp);
				}, "json");
			}

			function init() {
				init_security(false);
				get_configuration();
				populate_otp_tip();
			}

			function get_configuration() {
				$.get( "/node/config", function( data ) {
					$( '#application_name' ).val(data.application_name);
					$( '#element_name' ).val(data.element_name);
				}, "json");
			}

			function configure() {
				$.ajax({
				   type: 'PATCH',
				   url: '/node/config',
				   data: JSON.stringify({"application_name":$("#application_name").val(),"element_name":$("#element_name").val()}),
				   processData: false,
				   contentType: 'application/json-patch+json',
				   success: function() {alert("Configuration successful!")}
				});
			}

			function populate_otp_tip() {
				perimica_url = window.location.href;
				perimica_url = perimica_url.slice(8,-1);
				document.getElementById("otp_tip").innerHTML = `Click on <i>Generate</i> button to get the password to access the container as <b>root</b> user.<br/><br/>
							 Windows users can use the tool <i>Putty</i> to access the container via <i>ssh</i>. <br/><br/>
							 For Linux/macOS terminal use the command: <b> ssh root@` + perimica_url + `</b><br/><br/>
							 <b>Important hint:</b> the generated password can be used just <b>once</b>! 
							 To avoid the necessity to provide the password in each access you can copy your <i>public key</i> inside the container file: <b>~/.ssh/authorized_users</b>.
							 Linux/macOS users can use the command <b>ssh-copy-id root@` + perimica_url + `</b> to easily copy the key.`;
			}
		</script>
	</head>

	<body onload=init()>
		<div class="headercontainer">
			<!--Metanav-->
			<div class="meta">
				<div class="left" style="line-height: 24px;font-weight: bold;">Alpine</div>
				<div class="middle"></div>
				<div class="right"><span></span></div>
			</div>
			<!--END Metanav-->

			<div class="header" id="header_cnt">
				<div class="headerlogo"><img src="images/logo_perinet.png" width="258" height="94" alt="" /></div>
			</div>
		</div>

		<!--Content-->
		<div id="content">
			<div id="inner_content">
				<div class="contentinput" style="padding-bottom: 50px;">
					<div class="inputitem" style="margin-bottom: 100px;">
						<section>
							<h2>Description</h2>
							The <span style="font-weight:bold;">Alpine</span> container is provided as a template for developing your own application. For detailed information on how to use it and how to deploy your own customized web application, please check the <a target="_blank" href="https://docs.perinet.io/">documentation</a>.
							
							<div class="contentline_single gap10_20" style="margin-top:50px"></div>
							<div class="contentinput" style="margin-bottom: 20px;">
								<h2>Node configuration</h2>
								<table style="padding-left:60px">
									<tr>
										<td colspan="2" class="left"></td>
									</tr>
									<tr>
										<td class="left">Application name:</td>
										<td class="input">
											<input style="margin-left:55px; width:315px;" type="text" id="application_name" placeholder="application"></input>
										</td>
									</tr>
									<tr>
										<td colspan="2" class="left"></td>
									</tr>
									<tr></tr>
										<td class="left">Element name:</td>
										<td class="input">
											<input style="margin-left:55px; width:315px;" type="text" id="element_name" placeholder="element"></input>
											<input type="submit" class="submit_bt enabled short nextto" enabled onclick="configure()" value="Configure">
										</td>
									</tr>
								</table>
							</div>
							<div class="contentline_single gap10_20" style="margin-top:50px"></div>
							<div class="contentinput" style="margin-bottom: 20px;">
								<h2>SSH access</h2>
								<table style="padding-left:60px">
									<tr>
										<td colspan="2" class="left"></td>
									</tr>
									<tr>
										<td class="left">SSH one time password:</td>
										<td class="input">
											<div style="position: relative">
												<div class="help-tip"></div>
												<label>
													<p id="otp_tip" class="otp_tip">
													</p>
												</label>
											</div>
											<input style="margin-left:55px; width:315px;" type="text" readonly id="otp_text" placeholder="Generate OTP for root"></input>
											<input type="submit" class="submit_bt enabled short nextto" enabled onclick="generate_otp()" value="Generate">
										</td>
									</tr>
								</table>
							</div>

							<div class="contentline_single gap10_20" style="margin-top:50px"></div>

							<div class="contentinput" style="margin-bottom: 20px;">
								<h2>Security configuration</h2>
								<table id="security_table" align="left">
								</table>
							</div>

							<div class="contentline_single gap10_20" style="margin-top:50px"></div>

							<h2>Documentation</h2>
							The <span style="font-weight:bold;">Alpine</span> container provides an easy way to
							visualize distributed application related data. For further information refer to
							<a target="_blank" href="https://docs.perinet.io/">Perinet documentation</a> or
							to the <a target="_blank" href="api.html">Alpine API documentation</a>.

						</section>
					</div>
				</div>


				<!--Footer-->
				<br>
				<div class="footer">
					<div>
						<div style="float:left;width:140px;text-align:left;font-weight:bold;">periMICA</div>
						<div style="float:left;width:780px;text-align:right;"><span></span></div>
					</div>
				</div>

			</div>
		</div>

	</body>
</html>
